#pragma once

class HistoryLoader :
    public sample_tools::AThread
{
public:
    HistoryLoader(IInstance* instance,
                  int cookie,
                  CIndicatorBarSource* barSource,
                  DATE from,
                  DATE to,
                  IO2GSession *session,
                  std::string &csvSource,
                  HANDLE notifyFinished = INVALID_HANDLE_VALUE);
    ~HistoryLoader(void);
    const char *getError();

private:
    virtual int run();

    IO2GSession *mSession;
    IIndicatorInstance *mIndicatorInstance;
    int mCookie;
    DATE mDateFrom;
    DATE mDateTo;
    std::string mCSVSource;
    CIndicatorBarSource *mIndicatorBarSource;
    std::string mError;
    HANDLE mNotifyFinished;
};
