#pragma once

class CSVHistoryLoader
{
public:
    CSVHistoryLoader();
    ~CSVHistoryLoader();
    void getHistoricalData(CIndicatorBarSource *source,
                           DATE dateFrom,
                           DATE dateTo);
    bool loadCSV(const char *fileName, bool bid);
    DATE getDateFrom();
    DATE getDateTo();
private:
    std::string mInstrument;
    std::string mTimeframe;
    std::vector<Bar*> mBars;
    DATE mDateFrom;
    DATE mDateTo;
};
