#pragma once

class FXConnectHistoryLoader
{
public:
    FXConnectHistoryLoader(IO2GSession *session);
    ~FXConnectHistoryLoader(void);

    void getHistoricalData(CIndicatorBarSource *source,
                           DATE dateFrom,
                           DATE dateTo);
    const char *getError();

private:
    IO2GSession *mSession;
    std::string mError;

    IO2GOfferRow *getOffer(const char *instrument);
};
